package com.jiayue.simulation.ice102.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jiayue.simulation.util.IEC102Uitl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ClientService {

    private String zh1 = "105AFFFF5916";
    private String zh2 = "105BFFFF5916";

    public String sendMessage(String receiveMessage){

        String sendMessage = "";
        String[] rmArray = IEC102Uitl.stingToArray(receiveMessage);

        //召唤链路状态
        if (rmArray.length==0) {
            sendMessage = "1049FFFF4716";
        }else if(receiveMessage.startsWith("100B")){
            //链路状态回应请求->复位通信单元
            sendMessage = "1040FFFF3E16";
        }else if(receiveMessage.startsWith("1000")){
            //确认帧->召唤二级数据
            if(!zh2.equals("105BFFFF5916")){
                sendMessage = "105BFFFF5916";
            }else {
                sendMessage = "105AFFFF5816";
            }
            zh2 = sendMessage;
        }else if(receiveMessage.startsWith("1009")){
            //没有召唤数据->召唤二级数据
            if(!zh2.equals("105BFFFF5916")){
                sendMessage = "105BFFFF5916";
            }else {
                sendMessage = "107BFFFF7916";
            }
            zh2 = sendMessage;
        }else if(receiveMessage.startsWith("1029")){
            //希望船速数据->召唤一级数据

            if(!zh1.equals("107AFFFF7816")){
                sendMessage = "107AFFFF7816";
            }else {
                sendMessage = "105AFFFF5816";
            }
            zh1 = sendMessage;
        }else if(rmArray[9].equals("0B")){

            if(!zh2.equals("105BFFFF5916")){
                sendMessage = "105BFFFF5916";
            }else {
                sendMessage = "107BFFFF7916";
            }
            zh2 = sendMessage;
        }else if(receiveMessage.startsWith("68")&&receiveMessage.endsWith("16")){
            //68开头16结尾为数据船速；；希望传输数据->召唤一级数据

            if(rmArray[9].equals("08")){
                //文件传输未完成（还有内容）
                if(!zh1.equals("107AFFFF7816")){
                    sendMessage = "107AFFFF7816";
                }else {
                    sendMessage = "105AFFFF5816";
                }
                zh1 = sendMessage;
            }else if (rmArray[9].equals("07")){
                //文件传输结束
                sendMessage = "680D006873FFFF96010AFFFF00CE4600002416";
            }

        }


        return sendMessage.toUpperCase();

    }
}
