package com.jiayue.simulation.ice102.codec;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;

import java.math.BigInteger;

/**
 * 编码器
 *
 * @author tl
 */
public class Encoder extends MessageToByteEncoder<String> {
    @Override
    protected void encode(ChannelHandlerContext ctx, String msg, ByteBuf out) throws Exception {
        BigInteger bigint = new BigInteger(msg, 16);
        out.writeBytes(bigint.toByteArray());
    }

}